# This file was auto-generated by Fern from our API Definition.

import typing

import httpx

from .core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .resources.athome_phlebotomy.client import AsyncAthomePhlebotomyClient, AthomePhlebotomyClient
from .resources.body.client import AsyncBodyClient, BodyClient
from .resources.devices.client import AsyncDevicesClient, DevicesClient
from .resources.lab_tests.client import AsyncLabTestsClient, LabTestsClient
from .resources.labtests.client import AsyncLabtestsClient, LabtestsClient
from .resources.link.client import AsyncLinkClient, LinkClient
from .resources.meals.client import AsyncMealsClient, MealsClient
from .resources.order.client import AsyncOrderClient, OrderClient
from .resources.orders.client import AsyncOrdersClient, OrdersClient
from .resources.physician.client import AsyncPhysicianClient, PhysicianClient
from .resources.profile.client import AsyncProfileClient, ProfileClient
from .resources.providers.client import AsyncProvidersClient, ProvidersClient
from .resources.sleep.client import AsyncSleepClient, SleepClient
from .resources.summary.client import AsyncSummaryClient, SummaryClient
from .resources.team.client import AsyncTeamClient, TeamClient
from .resources.timeseries.client import AsyncTimeseriesClient, TimeseriesClient
from .resources.user.client import AsyncUserClient, UserClient
from .resources.users.client import AsyncUsersClient, UsersClient
from .resources.vitals.client import AsyncVitalsClient, VitalsClient
from .resources.webhook.client import AsyncWebhookClient, WebhookClient
from .resources.workouts.client import AsyncWorkoutsClient, WorkoutsClient


class Vital:
    def __init__(self, *, base_url: str, timeout: typing.Optional[float] = 60):
        self._client_wrapper = SyncClientWrapper(base_url=base_url, httpx_client=httpx.Client(timeout=timeout))
        self.webhook = WebhookClient(client_wrapper=self._client_wrapper)
        self.link = LinkClient(client_wrapper=self._client_wrapper)
        self.profile = ProfileClient(client_wrapper=self._client_wrapper)
        self.summary = SummaryClient(client_wrapper=self._client_wrapper)
        self.devices = DevicesClient(client_wrapper=self._client_wrapper)
        self.workouts = WorkoutsClient(client_wrapper=self._client_wrapper)
        self.sleep = SleepClient(client_wrapper=self._client_wrapper)
        self.body = BodyClient(client_wrapper=self._client_wrapper)
        self.meals = MealsClient(client_wrapper=self._client_wrapper)
        self.vitals = VitalsClient(client_wrapper=self._client_wrapper)
        self.timeseries = TimeseriesClient(client_wrapper=self._client_wrapper)
        self.users = UsersClient(client_wrapper=self._client_wrapper)
        self.user = UserClient(client_wrapper=self._client_wrapper)
        self.team = TeamClient(client_wrapper=self._client_wrapper)
        self.providers = ProvidersClient(client_wrapper=self._client_wrapper)
        self.physician = PhysicianClient(client_wrapper=self._client_wrapper)
        self.labtests = LabtestsClient(client_wrapper=self._client_wrapper)
        self.lab_tests = LabTestsClient(client_wrapper=self._client_wrapper)
        self.order = OrderClient(client_wrapper=self._client_wrapper)
        self.athome_phlebotomy = AthomePhlebotomyClient(client_wrapper=self._client_wrapper)
        self.orders = OrdersClient(client_wrapper=self._client_wrapper)


class AsyncVital:
    def __init__(self, *, base_url: str, timeout: typing.Optional[float] = 60):
        self._client_wrapper = AsyncClientWrapper(base_url=base_url, httpx_client=httpx.AsyncClient(timeout=timeout))
        self.webhook = AsyncWebhookClient(client_wrapper=self._client_wrapper)
        self.link = AsyncLinkClient(client_wrapper=self._client_wrapper)
        self.profile = AsyncProfileClient(client_wrapper=self._client_wrapper)
        self.summary = AsyncSummaryClient(client_wrapper=self._client_wrapper)
        self.devices = AsyncDevicesClient(client_wrapper=self._client_wrapper)
        self.workouts = AsyncWorkoutsClient(client_wrapper=self._client_wrapper)
        self.sleep = AsyncSleepClient(client_wrapper=self._client_wrapper)
        self.body = AsyncBodyClient(client_wrapper=self._client_wrapper)
        self.meals = AsyncMealsClient(client_wrapper=self._client_wrapper)
        self.vitals = AsyncVitalsClient(client_wrapper=self._client_wrapper)
        self.timeseries = AsyncTimeseriesClient(client_wrapper=self._client_wrapper)
        self.users = AsyncUsersClient(client_wrapper=self._client_wrapper)
        self.user = AsyncUserClient(client_wrapper=self._client_wrapper)
        self.team = AsyncTeamClient(client_wrapper=self._client_wrapper)
        self.providers = AsyncProvidersClient(client_wrapper=self._client_wrapper)
        self.physician = AsyncPhysicianClient(client_wrapper=self._client_wrapper)
        self.labtests = AsyncLabtestsClient(client_wrapper=self._client_wrapper)
        self.lab_tests = AsyncLabTestsClient(client_wrapper=self._client_wrapper)
        self.order = AsyncOrderClient(client_wrapper=self._client_wrapper)
        self.athome_phlebotomy = AsyncAthomePhlebotomyClient(client_wrapper=self._client_wrapper)
        self.orders = AsyncOrdersClient(client_wrapper=self._client_wrapper)
